var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import React from 'react';
import { connect } from 'react-redux';
export var RegisteredWrapper = function (_a) {
    var component = _a.component, props = __rest(_a, ["component"]);
    if (component) {
        return React.createElement(component, props);
    }
    return null;
};
var plugin = function (app, namespace) {
    if (namespace === void 0) { namespace = '@@registry'; }
    var registry = app.model(namespace, {
        mapping: {}
    });
    var mutations = registry.mutations({
        register: function (name, comp) { return function (s) {
            var _a;
            var mapping = s.get('mapping');
            return s.set('mapping', __assign({}, mapping, (_a = {}, _a[name] = comp, _a)));
        }; }
    })[0];
    var Registered = function (_a) {
        var name = _a.name, children = _a.children, props = __rest(_a, ["name", "children"]);
        var mapStateToProps = function (state) {
            var mapping = registry.state.get('mapping')(state);
            return {
                component: mapping[name]
            };
        };
        var Connected = connect(mapStateToProps)(RegisteredWrapper);
        if (typeof children === 'function') {
            return children(Connected, props);
        }
        return React.createElement(Connected, __assign({}, props));
    };
    return {
        mutations: mutations,
        state: registry.state,
        Component: Registered,
        register: function (name, comp) { return app.store.dispatch(mutations.register(name, comp)); },
    };
};
export default plugin;
//# sourceMappingURL=registry.plugin.js.map